(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var Random = Package.random.Random;
var _ = Package.underscore._;
var SandstormDb = Package['sandstorm-db'].SandstormDb;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var SandstormPermissions, path;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-permissions":{"permissions.js":["babel-runtime/helpers/classCallCheck",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-permissions/permissions.js                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck;module.import("babel-runtime/helpers/classCallCheck",{"default":function(v){_classCallCheck=v}});  //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
SandstormPermissions = {};                                                                                             // 19
                                                                                                                       //
var PermissionSet = function () {                                                                                      //
  // A wrapper around an array of booleans representing a set of permissions like "read" or                            //
  // "write". This might represent the permissions held by some user on some grain, or it might                        //
  // represent the permissions that one user has chosen to share with another user.                                    //
  //                                                                                                                   //
  // In our model, permissions are independent. You can have "read" without "write" and you can                        //
  // have "write" without "read". Many apps don't actually allow arbitrary permutations, and                           //
  // instead define "roles" like "editor" or "viewer", where "editor" implies both read and write                      //
  // permission while "viewer" implies only read. Roles, however, are just aliases for sets of                         //
  // permissions; all actual computation is done on permissions.                                                       //
                                                                                                                       //
  function PermissionSet(array) {                                                                                      // 32
    _classCallCheck(this, PermissionSet);                                                                              // 32
                                                                                                                       //
    if (!array) {                                                                                                      // 33
      this.array = [];                                                                                                 // 34
    } else if (array instanceof Array) {                                                                               // 35
      this.array = array.slice(0);                                                                                     // 36
    } else {                                                                                                           // 37
      throw new Error("don't know how to interpret as PermissionSet: " + array);                                       // 38
    }                                                                                                                  // 39
  }                                                                                                                    // 40
                                                                                                                       //
  PermissionSet.fromRoleAssignment = function fromRoleAssignment(roleAssignment, viewInfo) {                           //
    // Create a PermissionSet based on a ViewSharingLink.RoleAssignment and a UiView.ViewInfo (as                      //
    // defined in grain.capnp). ViewInfo defines a mapping from roles to permission sets for a                         //
    // particular grain type. RoleAssignment represents the permissions passed from one user to                        //
    // another -- usually it specifies a single role, but sometimes also specifies permissions to                      //
    // add or remove as well.                                                                                          //
    //                                                                                                                 //
    // A falsy value for `roleAssignment` is considered equivalent to a "none" value, which means                      //
    // that no role was explicitly chosen, so the default role should be assigned.                                     //
                                                                                                                       //
    var result = new PermissionSet([]);                                                                                // 52
                                                                                                                       //
    if (!roleAssignment || "none" in roleAssignment) {                                                                 // 54
      // No role explicitly chosen, e.g. because the app did not define any roles at the time                          //
      // the sharing took place. Assign the default role, if there is one.                                             //
                                                                                                                       //
      if (viewInfo.roles) {                                                                                            // 58
        for (var ii = 0; ii < viewInfo.roles.length; ++ii) {                                                           // 59
          var roleDef = viewInfo.roles[ii];                                                                            // 60
          if (roleDef["default"]) {                                                                                    // 61
            result = new PermissionSet(roleDef.permissions);                                                           // 62
            break;                                                                                                     // 63
          }                                                                                                            // 64
        }                                                                                                              // 65
      }                                                                                                                // 66
    } else if ("allAccess" in roleAssignment) {                                                                        // 67
      // All permissions are shared, even if there is no explicitly-defined role for this.                             //
                                                                                                                       //
      var length = 0;                                                                                                  // 70
      if (viewInfo.permissions) {                                                                                      // 71
        length = viewInfo.permissions.length;                                                                          // 72
      }                                                                                                                // 73
                                                                                                                       //
      var array = new Array(length);                                                                                   // 75
      for (var _ii = 0; _ii < array.length; ++_ii) {                                                                   // 76
        array[_ii] = true;                                                                                             // 77
      }                                                                                                                // 78
                                                                                                                       //
      result = new PermissionSet(array);                                                                               // 80
    } else if ("roleId" in roleAssignment && viewInfo.roles && viewInfo.roles.length > 0) {                            // 81
      // A specific role was chosen.                                                                                   //
                                                                                                                       //
      var _roleDef = viewInfo.roles[roleAssignment.roleId];                                                            // 84
      if (_roleDef) {                                                                                                  // 85
        result = new PermissionSet(_roleDef.permissions);                                                              // 86
      }                                                                                                                // 87
    }                                                                                                                  // 88
                                                                                                                       //
    if (roleAssignment) {                                                                                              // 90
      // Add or remove specific permissions. This is uncommon.                                                         //
      result.add(new PermissionSet(roleAssignment.addPermissionSet));                                                  // 92
      result.remove(new PermissionSet(roleAssignment.removePermissionSet));                                            // 93
    }                                                                                                                  // 94
                                                                                                                       //
    return result;                                                                                                     // 96
  };                                                                                                                   // 97
                                                                                                                       //
  PermissionSet.prototype.isEmpty = function isEmpty() {                                                               //
    var result = true;                                                                                                 // 100
    this.array.forEach(function (p) {                                                                                  // 101
      if (p) {                                                                                                         // 102
        result = false;                                                                                                // 103
      }                                                                                                                // 104
    });                                                                                                                // 105
                                                                                                                       //
    return result;                                                                                                     // 107
  };                                                                                                                   // 108
                                                                                                                       //
  PermissionSet.prototype.isSubsetOf = function isSubsetOf(other) {                                                    //
    check(other, PermissionSet);                                                                                       // 111
    for (var ii = 0; ii < this.array.length; ++ii) {                                                                   // 112
      var mine = this.array[ii];                                                                                       // 113
      var yours = other.array[ii] || false;                                                                            // 114
      if (mine && !yours) {                                                                                            // 115
        return false;                                                                                                  // 116
      }                                                                                                                // 117
    }                                                                                                                  // 118
                                                                                                                       //
    return true;                                                                                                       // 120
  };                                                                                                                   // 121
                                                                                                                       //
  // Methods for mutating a PermissionSet by combining it with another PermissionSet.                                  //
  // These return a boolean indicating whether the operation had any effect.                                           //
                                                                                                                       //
  PermissionSet.prototype.add = function add(other) {                                                                  //
    check(other, PermissionSet);                                                                                       // 127
    var changed = false;                                                                                               // 128
    for (var ii = 0; ii < other.array.length; ++ii) {                                                                  // 129
      var old = !!this.array[ii];                                                                                      // 130
      this.array[ii] = !!this.array[ii] || other.array[ii];                                                            // 131
      if (old !== this.array[ii]) {                                                                                    // 132
        changed = true;                                                                                                // 133
      }                                                                                                                // 134
    }                                                                                                                  // 135
                                                                                                                       //
    return changed;                                                                                                    // 137
  };                                                                                                                   // 138
                                                                                                                       //
  PermissionSet.prototype.remove = function remove(other) {                                                            //
    check(other, PermissionSet);                                                                                       // 141
    var changed = false;                                                                                               // 142
    for (var ii = 0; ii < other.array.length && ii < this.array.length; ++ii) {                                        // 143
      var old = !!this.array[ii];                                                                                      // 144
      this.array[ii] = !!this.array[ii] && !other.array[ii];                                                           // 145
      if (old !== this.array[ii]) {                                                                                    // 146
        changed = true;                                                                                                // 147
      }                                                                                                                // 148
    }                                                                                                                  // 149
                                                                                                                       //
    return changed;                                                                                                    // 151
  };                                                                                                                   // 152
                                                                                                                       //
  PermissionSet.prototype.intersect = function intersect(other) {                                                      //
    check(other, PermissionSet);                                                                                       // 155
    var changed = false;                                                                                               // 156
    for (var ii = 0; ii < this.array.length; ++ii) {                                                                   // 157
      var old = !!this.array[ii];                                                                                      // 158
      this.array[ii] = !!this.array[ii] && other.array[ii];                                                            // 159
      if (old !== this.array[ii]) {                                                                                    // 160
        changed = true;                                                                                                // 161
      }                                                                                                                // 162
    }                                                                                                                  // 163
                                                                                                                       //
    return changed;                                                                                                    // 165
  };                                                                                                                   // 166
                                                                                                                       //
  return PermissionSet;                                                                                                //
}();                                                                                                                   //
                                                                                                                       //
var RequirementSet = function () {                                                                                     //
  // A conjunction of permissions for identities on grains.                                                            //
  //                                                                                                                   //
  // This typically represents a set of `MembraneRequirement`s, as defined in `supervisor.capnp`.                      //
  // These represent conditions under which some connection formed between grains remains valid.                       //
  // When a capability travels from grain to grain, it passes across these connections -- if any                       //
  // of the connections becomes invalid (is revoked), then the capability must be revoked as well.                     //
  // The word "membrane" comes from the concept of revokable membranes; the capability is passing                      //
  // across such membranes as it travels.                                                                              //
  //                                                                                                                   //
  // For example, a RequirementSet might represent the statement "Alice has read access to Foo, Bob                    //
  // has write access to Foo, and Bob has read access to Bar". Specifically, this example situation                    //
  // would come about if:                                                                                              //
  // - Bob used his read access to Bar to extract a capability from it.                                                //
  // - Bob embedded that capability into Foo, using his write access.                                                  //
  // - Alice extracted the capability from Foo, using her read access.                                                 //
  // If any of these permissions are revoked, then the capability needs to be revoked as well.                         //
                                                                                                                       //
  function RequirementSet() {                                                                                          // 187
    _classCallCheck(this, RequirementSet);                                                                             // 187
                                                                                                                       //
    this.permissionsHeldRequirements = {};                                                                             // 188
    // Map from grain ID to objects of the form { identities, tokens }, where `identities` is a                        //
    // map from identity ID to PermissionSet and `tokens` is a map from token ID to PermissionSet.                     //
    // Represents a set of `permissionsHeld` requirements.                                                             //
                                                                                                                       //
    this.userIsAdminRequirements = {};                                                                                 // 193
    // Map from account ID to boolean. Represents a set of `userIsAdmin` requirements.                                 //
                                                                                                                       //
    this.tokenValidRequirements = {};                                                                                  // 196
    // Map from token ID to boolean. Represents a set of `tokenValid` requirements.                                    //
  }                                                                                                                    // 198
                                                                                                                       //
  RequirementSet.prototype.isEmpty = function isEmpty() {                                                              //
    for (var tokenId in this.tokenValidRequirements) {                                                                 // 201
      return false;                                                                                                    // 202
    }                                                                                                                  // 203
                                                                                                                       //
    for (var grainId in this.permissionsHeldRequirements) {                                                            // 205
      if (Object.keys(this.permissionsHeldRequirements[grainId]).length > 0) {                                         // 206
        return false;                                                                                                  // 207
      }                                                                                                                // 208
    }                                                                                                                  // 209
                                                                                                                       //
    return true;                                                                                                       // 211
  };                                                                                                                   // 212
                                                                                                                       //
  RequirementSet.prototype.addRequirements = function addRequirements(requirements) {                                  //
    var _this = this;                                                                                                  // 214
                                                                                                                       //
    // Updates this RequirementSet to include the permissions required by `requirements`, which                        //
    // is a decoded Cap'n Proto List(MembraneRequirement).                                                             //
                                                                                                                       //
    if (!requirements) return;                                                                                         // 218
    requirements.forEach(function (requirement) {                                                                      // 219
      if (requirement.permissionsHeld) {                                                                               // 220
        var grainId = requirement.permissionsHeld.grainId;                                                             // 221
        var permissions = new PermissionSet(requirement.permissionsHeld.permissions);                                  // 222
                                                                                                                       //
        if (!_this.permissionsHeldRequirements[grainId]) {                                                             // 224
          _this.permissionsHeldRequirements[grainId] = { identities: {}, tokens: {} };                                 // 225
        }                                                                                                              // 226
                                                                                                                       //
        var grainReqs = _this.permissionsHeldRequirements[grainId];                                                    // 228
                                                                                                                       //
        if (requirement.permissionsHeld.identityId) {                                                                  // 230
          var identityId = requirement.permissionsHeld.identityId;                                                     // 231
          if (!grainReqs.identities[identityId]) {                                                                     // 232
            grainReqs.identities[identityId] = new PermissionSet([]);                                                  // 233
          }                                                                                                            // 234
                                                                                                                       //
          grainReqs.identities[identityId].add(permissions);                                                           // 236
        } else if (requirement.permissionsHeld.tokenId) {                                                              // 237
          var tokenId = requirement.permissionsHeld.tokenId;                                                           // 238
          if (!grainReqs.tokens[tokenId]) {                                                                            // 239
            grainReqs.tokens[tokenId] = new PermissionSet([]);                                                         // 240
          }                                                                                                            // 241
                                                                                                                       //
          grainReqs.tokens[tokenId].add(permissions);                                                                  // 243
        } else {                                                                                                       // 245
          throw new Error("unrecognized permissionsHeld requirement", JSON.stringify(requirement));                    // 246
        }                                                                                                              // 247
      } else if (requirement.userIsAdmin) {                                                                            // 248
        _this.userIsAdminRequirements[requirement.userIsAdmin] = true;                                                 // 249
      } else if (requirement.tokenValid) {                                                                             // 250
        _this.tokenValidRequirements[requirement.tokenValid] = true;                                                   // 251
      } else {                                                                                                         // 252
        throw new Error("unsupported requirement: " + JSON.toString(requirement));                                     // 253
      }                                                                                                                // 254
    });                                                                                                                // 255
  };                                                                                                                   // 256
                                                                                                                       //
  RequirementSet.prototype.getGrainIds = function getGrainIds() {                                                      //
    return Object.keys(this.permissionsHeldRequirements);                                                              // 259
  };                                                                                                                   // 260
                                                                                                                       //
  RequirementSet.prototype.getTokenIds = function getTokenIds() {                                                      //
    return Object.keys(this.tokenValidRequirements);                                                                   // 263
  };                                                                                                                   // 264
                                                                                                                       //
  RequirementSet.prototype.forEach = function forEach(func) {                                                          //
    for (var tokenId in this.tokenValidRequirements) {                                                                 // 267
      func({ tokenValid: tokenId });                                                                                   // 268
    }                                                                                                                  // 269
                                                                                                                       //
    for (var accountId in this.userIsAdminRequirements) {                                                              // 271
      func({ userIsAdmin: accountId });                                                                                // 272
    }                                                                                                                  // 273
                                                                                                                       //
    for (var grainId in this.permissionsHeldRequirements) {                                                            // 275
      for (var identityId in this.permissionsHeldRequirements[grainId].identities) {                                   // 276
        var permissionSet = this.permissionsHeldRequirements[grainId].identities[identityId];                          // 277
        func({ permissionsHeld: { grainId: grainId, identityId: identityId, permissionSet: permissionSet } });         // 278
      }                                                                                                                // 279
                                                                                                                       //
      for (var _tokenId in this.permissionsHeldRequirements[grainId].tokens) {                                         // 281
        var _permissionSet = this.permissionsHeldRequirements[grainId].tokens[_tokenId];                               // 282
        func({ permissionsHeld: { grainId: grainId, tokenId: _tokenId, permissionSet: _permissionSet } });             // 283
      }                                                                                                                // 284
    }                                                                                                                  // 285
  };                                                                                                                   // 286
                                                                                                                       //
  return RequirementSet;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
// A permission ID is either the string "canAccess", corresponding to the implicit "can access                         //
// the grain at all" permission, or a non-negative integer, corresponding to a permission                              //
// defined by the app in its manifest.                                                                                 //
                                                                                                                       //
                                                                                                                       //
var PermissionId = Match.OneOf("canAccess", Match.Integer);                                                            // 292
                                                                                                                       //
function forEachPermission(permissions, func) {                                                                        // 294
  // Calls `func` on "canAccess" and each permission ID that corresponds to a `true`                                   //
  // value in `permissions`.                                                                                           //
  check(permissions, [Boolean]);                                                                                       // 297
  func("canAccess");                                                                                                   // 298
  for (var ii = 0; ii < permissions.length; ++ii) {                                                                    // 299
    if (permissions[ii]) {                                                                                             // 300
      func(ii);                                                                                                        // 301
    }                                                                                                                  // 302
  }                                                                                                                    // 303
}                                                                                                                      // 304
                                                                                                                       //
// A vertex is a principal in the sharing graph. A "vertex ID" is either "i:" + an identity ID,                        //
// or "t:" + a token ID. In some limited contexts, "o:Owner" is also allowed, signifying the                           //
// *account* of the grain owner, from which all permissions flow.                                                      //
                                                                                                                       //
var vertexIdOfTokenOwner = function vertexIdOfTokenOwner(token) {                                                      // 310
  // Returns which vertex recieves permissions from this token.                                                        //
                                                                                                                       //
  var result = "t:" + token._id; // the bearer of the token                                                            // 313
  if (token.owner && token.owner.user) {                                                                               // 314
    result = "i:" + token.owner.user.identityId; // the identity that owns the token                                   // 315
  }                                                                                                                    // 316
                                                                                                                       //
  return result;                                                                                                       // 318
};                                                                                                                     // 319
                                                                                                                       //
var vertexIdOfPermissionsHeld = function vertexIdOfPermissionsHeld(held) {                                             // 321
  if (held.identityId) {                                                                                               // 322
    return "i:" + held.identityId;                                                                                     // 323
  } else if (held.tokenId) {                                                                                           // 324
    return "t:" + held.tokenId;                                                                                        // 325
  } else {                                                                                                             // 326
    throw new Error("Unrecognized permissionsHeld: " + JSON.stringify(held));                                          // 327
  }                                                                                                                    // 328
};                                                                                                                     // 329
                                                                                                                       //
var Variable =                                                                                                         //
// Our permissions computation can be framed as a propositional HORNSAT problem; this `Variable`                       //
// class represents a variable in that sense. There is a variable for every (grain ID, vertex ID,                      //
// permission ID) triple. There is also a variable for every non-UiView ApiToken, to account for                       //
// `tokenValid` requirements. In any given computation, we only explicitly construct those                             //
// variables that we know might actually be relevant to the result.                                                    //
//                                                                                                                     //
// The value of a variable represents an answer to the question "does this vertex in the sharing                       //
// graph receive this permission at this grain?" We start out by setting all variables to `false`,                     //
// and we only set a variable to `true` when an edge in the sharing graph forces us to. If                             //
// this forward-chaining eventually forces us to set our end goal variables to `true`, then the                        //
// HORNSAT problem is unsatisfiable and we have proved what we wanted. Otherwise, the HORNSAT                          //
// problem is satisfiable, i.e. there is a consistent way to set values to variables in which                          //
// our goal nodes do *not* receive the permissions we wanted them to receive.                                          //
                                                                                                                       //
function Variable() {                                                                                                  // 346
  _classCallCheck(this, Variable);                                                                                     // 346
                                                                                                                       //
  this.value = false;                                                                                                  // 347
                                                                                                                       //
  this.directDependents = [];                                                                                          // 349
  // List of token IDs for outgoing edges that need to be looked at once this variable gets set                        //
  // to `true`.                                                                                                        //
                                                                                                                       //
  this.requirementDependents = [];                                                                                     // 353
  // List of token IDs for tokens that have requirements that get fulfilled once this variable                         //
  // gets set to `true`.                                                                                               //
};                                                                                                                     // 356
                                                                                                                       //
var ActiveToken = function () {                                                                                        //
  // An "active token" is one that we allow to propagate permissions because we've decided                             //
  // that it might be relevant to our current computation. This class tracks which permissions                         //
  // the token can carry, which of those permissions we've actually proved to arrive at the source                     //
  // end of the token, and how many of the token's requirements are still unmet.                                       //
                                                                                                                       //
  function ActiveToken(tokenId, requirements, numUnmetRequirements, permissions, grainId, recipientId) {               // 365
    _classCallCheck(this, ActiveToken);                                                                                // 365
                                                                                                                       //
    check(tokenId, String);                                                                                            // 366
    check(numUnmetRequirements, Match.Integer);                                                                        // 367
    check(grainId, String);                                                                                            // 368
    check(recipientId, String);                                                                                        // 369
                                                                                                                       //
    check(permissions, [Boolean]);                                                                                     // 371
    // The permissions that this token is capable of carrying, in addition to the implicit                             //
    // "canAccess" permission.                                                                                         //
                                                                                                                       //
    this.tokenId = tokenId;                                                                                            // 375
    this.requirements = requirements;                                                                                  // 376
    this.grainId = grainId;                                                                                            // 377
    this.recipientId = recipientId;                                                                                    // 378
                                                                                                                       //
    this.numUnmetRequirements = numUnmetRequirements;                                                                  // 380
    // How many of this token's requirements we have not yet proven to be met.                                         //
                                                                                                                       //
    this.receivedPermissions = new Array();                                                                            // 383
    // A map from permission ID to boolean. If a permission ID is present in this map,                                 //
    // then this token's roleAssignment includes that permission. If the corresponding                                 //
    // value is `true`, then we've proven that this token receives this permission and                                 //
    // therefore propagates it if the requirements are met.                                                            //
                                                                                                                       //
    this.receivedPermissions.canAccess = false;                                                                        // 389
    for (var ii = 0; ii < permissions.length; ++ii) {                                                                  // 390
      if (permissions[ii]) {                                                                                           // 391
        this.receivedPermissions[ii] = false;                                                                          // 392
      }                                                                                                                // 393
    }                                                                                                                  // 394
  }                                                                                                                    // 395
                                                                                                                       //
  ActiveToken.prototype.requirementsAreMet = function requirementsAreMet() {                                           //
    // Have we yet proved that all of this token's requirements are met?                                               //
    return this.numUnmetRequirements == 0;                                                                             // 399
  };                                                                                                                   // 400
                                                                                                                       //
  ActiveToken.prototype.decrementRequirements = function decrementRequirements(context) {                              //
    var _this2 = this;                                                                                                 // 402
                                                                                                                       //
    // Decrements the number of unmet requirements of this token.                                                      //
    check(context, Context);                                                                                           // 404
    this.numUnmetRequirements -= 1;                                                                                    // 405
    if (this.numUnmetRequirements < 0) {                                                                               // 406
      throw new Meteor.Error(500, "numUnmetRequirements is negative");                                                 // 407
    }                                                                                                                  // 408
                                                                                                                       //
    if (this.requirementsAreMet()) {                                                                                   // 410
      // This was the last missing requirement for this token, therefore we've triggered the                           //
      // outgoing edges from the token corresponding to each known incoming permission.                                //
      this.forEachReceivedPermission(function (permissionId) {                                                         // 413
        // We've triggered a new edge! Push it onto the queue.                                                         //
        context.setToTrueStack.push({ grainId: _this2.grainId,                                                         // 415
          vertexId: _this2.recipientId,                                                                                // 416
          permissionId: permissionId,                                                                                  // 417
          responsibleTokenId: _this2.tokenId });                                                                       // 418
      });                                                                                                              // 419
    }                                                                                                                  // 420
  };                                                                                                                   // 421
                                                                                                                       //
  ActiveToken.prototype.setReceivesPermission = function setReceivesPermission(permissionId, context) {                //
    // Records that this token receives a permission.                                                                  //
    check(permissionId, PermissionId);                                                                                 // 425
    check(context, Context);                                                                                           // 426
    if (permissionId in this.receivedPermissions) {                                                                    // 427
      this.receivedPermissions[permissionId] = true;                                                                   // 428
    }                                                                                                                  // 429
                                                                                                                       //
    if (this.numUnmetRequirements == 0) {                                                                              // 431
      context.setToTrueStack.push({ grainId: this.grainId,                                                             // 432
        vertexId: this.recipientId,                                                                                    // 433
        permissionId: permissionId,                                                                                    // 434
        responsibleTokenId: this.tokenId });                                                                           // 435
    } else {                                                                                                           // 436
      // Since we know permissions flow to this token, and the token is active (meaning it                             //
      // may be relevant to the overall computation), we now know that it's worth checking                             //
      // the token's requirements. Add them to `unmetRequirements`. Note that these requirement                        //
      // could actually be ones that we've checked already, but we'll figure that out once                             //
      // processUnmetRequirements() runs and discovers it isn't activating any new tokens.                             //
      //                                                                                                               //
      // TODO(perf): This is an overestimate. It might be worthwhile to keep track of which                            //
      //   requirements are already met, so that we don't need to add them here.                                       //
                                                                                                                       //
      context.unmetRequirements.addRequirements(this.requirements);                                                    // 446
    }                                                                                                                  // 447
  };                                                                                                                   // 448
                                                                                                                       //
  ActiveToken.prototype.forEachReceivedPermission = function forEachReceivedPermission(func) {                         //
    // Calls `func` on each permission ID that we've proven this token receives.                                       //
                                                                                                                       //
    if (this.receivedPermissions.canAccess) {                                                                          // 453
      func("canAccess");                                                                                               // 454
    }                                                                                                                  // 455
                                                                                                                       //
    // Note: Array.forEach() does hit the "canAccess" permission ID.                                                   //
    this.receivedPermissions.forEach(function (received, permissionId) {                                               // 458
      if (received) {                                                                                                  // 459
        func(permissionId);                                                                                            // 460
      }                                                                                                                // 461
    });                                                                                                                // 462
  };                                                                                                                   // 463
                                                                                                                       //
  return ActiveToken;                                                                                                  //
}();                                                                                                                   //
                                                                                                                       //
var Context = function () {                                                                                            //
  // An ongoing permissions computation, including cached database state.                                              //
                                                                                                                       //
  function Context() {                                                                                                 // 469
    _classCallCheck(this, Context);                                                                                    // 469
                                                                                                                       //
    this.grains = {}; // Map from grain ID to entry in Grains table.                                                   // 470
    this.userIdentityIds = {}; // Map from account ID to list of linked identity IDs.                                  // 471
    this.adminUsers = {}; // Set of account IDs for admins.                                                            // 472
    this.tokensById = {}; // Map from token ID to token.                                                               // 473
    this.tokensByRecipient = {}; // Map from grain ID and identity ID to token array.                                  // 474
                                                                                                                       //
    this.variables = {};                                                                                               // 476
    // GrainId -> VertexId -> PermissionId -> Variable                                                                 //
    //                                                                                                                 //
    // We have a special fake grain ID "tokenValid", where we store the variables that track                           //
    // `tokenValid` requirements. Only the "canAccess" permission makes sense for that fake grain.                     //
                                                                                                                       //
    this.userIsAdminVariables = {};                                                                                    // 482
    // Account ID -> Variable                                                                                          //
                                                                                                                       //
    this.activeTokens = {}; // TokenId -> ActiveToken                                                                  // 485
                                                                                                                       //
    this.setToTrueStack = [];                                                                                          // 487
    // Variables enqueued to be set to true.                                                                           //
    // Array of { grainId: String, vertexId: String, permissionId: PermissionId,                                       //
    //            responsibleTokenId: Optional(String) }                                                               //
                                                                                                                       //
    this.unmetRequirements = new RequirementSet();                                                                     // 492
    // As we run our forward-chaining algorithm, when we encounter a token with unmet requirements                     //
    // we add those requirements to this set. Then, if we find that our current knowledge base                         //
    // is not large enough to prove our goal, we can expand our search by following these                              //
    // requirements backwards and activating tokens that might help prove that they are met.                           //
    // `unmetRequirements` is allowed to be an overestimate -- in fact, when adding requirements                       //
    // to `unmetRequirements` we generally do not check if they had already been proven. The next                      //
    // run of processUnmetRequirements(), however, will find that all of the tokens activated by                       //
    // the requirements were already active.                                                                           //
  }                                                                                                                    // 501
                                                                                                                       //
  Context.prototype.reset = function reset() {                                                                         //
    // Resets all state except this.grains, this.userIdentityIds, and this.adminUsers.                                 //
    this.tokensById = {};                                                                                              // 505
    this.tokensByRecipient = {};                                                                                       // 506
    this.unmetRequirements = new RequirementSet();                                                                     // 507
    this.setToTrueStack = [];                                                                                          // 508
    this.variables = {};                                                                                               // 509
    this.activeTokens = {};                                                                                            // 510
  };                                                                                                                   // 511
                                                                                                                       //
  Context.prototype.addToken = function addToken(token) {                                                              //
    // Adds a token to `this.tokensById`. If the token is a UiView, also adds it to                                    //
    // `this.tokensByRecipient`. Does not activate the token.                                                          //
                                                                                                                       //
    var isUiView = token.grainId && !token.objectId;                                                                   // 517
                                                                                                                       //
    if (this.tokensById[token._id]) return;                                                                            // 519
                                                                                                                       //
    this.tokensById[token._id] = token;                                                                                // 521
    if (isUiView && token.owner && token.owner.user) {                                                                 // 522
      if (!this.tokensByRecipient[token.grainId]) {                                                                    // 523
        this.tokensByRecipient[token.grainId] = {};                                                                    // 524
      }                                                                                                                // 525
                                                                                                                       //
      if (!this.tokensByRecipient[token.grainId][token.owner.user.identityId]) {                                       // 527
        this.tokensByRecipient[token.grainId][token.owner.user.identityId] = [];                                       // 528
      }                                                                                                                // 529
                                                                                                                       //
      this.tokensByRecipient[token.grainId][token.owner.user.identityId].push(token);                                  // 531
    }                                                                                                                  // 532
  };                                                                                                                   // 533
                                                                                                                       //
  Context.prototype.addGrains = function addGrains(db, grainIds) {                                                     //
    var _this3 = this;                                                                                                 // 535
                                                                                                                       //
    // Retrieves grains from the database.                                                                             //
                                                                                                                       //
    check(db, SandstormDb);                                                                                            // 538
    check(grainIds, [String]);                                                                                         // 539
    if (grainIds.length == 0) return; // Nothing to do.                                                                // 540
                                                                                                                       //
    db.collections.grains.find({                                                                                       // 542
      _id: { $in: grainIds },                                                                                          // 543
      trashed: { $exists: false },                                                                                     // 544
      suspended: { $ne: true }                                                                                         // 545
    }).forEach(function (grain) {                                                                                      // 542
      _this3.grains[grain._id] = grain;                                                                                // 547
      if (!_this3.userIdentityIds[grain.userId]) {                                                                     // 548
        _this3.userIdentityIds[grain.userId] = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));
      }                                                                                                                // 551
    });                                                                                                                // 552
                                                                                                                       //
    var query = { grainId: { $in: grainIds },                                                                          // 554
      revoked: { $ne: true },                                                                                          // 555
      trashed: { $exists: false },                                                                                     // 556
      suspended: { $ne: true },                                                                                        // 557
      objectId: { $exists: false } };                                                                                  // 558
    db.collections.apiTokens.find(query).forEach(function (token) {                                                    // 559
      return _this3.addToken(token);                                                                                   // 559
    });                                                                                                                // 559
  };                                                                                                                   // 560
                                                                                                                       //
  Context.prototype.addTokensFromCursor = function addTokensFromCursor(cursor) {                                       //
    var _this4 = this;                                                                                                 // 562
                                                                                                                       //
    cursor.forEach(function (token) {                                                                                  // 563
      return _this4.addToken(token);                                                                                   // 563
    });                                                                                                                // 563
  };                                                                                                                   // 564
                                                                                                                       //
  Context.prototype.activateOwnerEdges = function activateOwnerEdges(grainId, edges) {                                 //
    var _this5 = this;                                                                                                 // 566
                                                                                                                       //
    check(edges, [{ identityId: String, role: SandstormDb.prototype.roleAssignmentPattern }]);                         // 567
                                                                                                                       //
    edges.forEach(function (edge) {                                                                                    // 569
      var viewInfo = _this5.grains[grainId].cachedViewInfo || {};                                                      // 570
      var permissions = PermissionSet.fromRoleAssignment(edge.role, viewInfo);                                         // 571
      var vertexId = "i:" + edge.identityId;                                                                           // 572
      forEachPermission(permissions.array, function (permissionId) {                                                   // 573
        _this5.setToTrueStack.push({                                                                                   // 574
          grainId: grainId,                                                                                            // 575
          vertexId: vertexId,                                                                                          // 576
          permissionId: permissionId                                                                                   // 577
        });                                                                                                            // 574
      });                                                                                                              // 579
    });                                                                                                                // 580
                                                                                                                       //
    return edges.length > 0;                                                                                           // 582
  };                                                                                                                   // 583
                                                                                                                       //
  Context.prototype.registerInterestInRequirements = function registerInterestInRequirements(tokenId, requirements) {  //
    var _this6 = this;                                                                                                 // 585
                                                                                                                       //
    // Add all requirements.                                                                                           //
    var numUnmetRequirements = 0;                                                                                      // 587
    if (requirements) {                                                                                                // 588
      requirements.forEach(function (requirement) {                                                                    // 589
        if (requirement.permissionsHeld) {                                                                             // 590
          (function () {                                                                                               // 590
            var reqGrainId = requirement.permissionsHeld.grainId;                                                      // 591
            var reqVertexId = vertexIdOfPermissionsHeld(requirement.permissionsHeld);                                  // 592
            var reqPermissions = requirement.permissionsHeld.permissions || [];                                        // 593
                                                                                                                       //
            forEachPermission(reqPermissions, function (permissionId) {                                                // 595
              var variable = _this6.getVariable(reqGrainId, reqVertexId, permissionId);                                // 596
              if (!variable.value) {                                                                                   // 597
                // This requirement hasn't been proven yet. We add it to the variable's list of                        //
                // dependents so that we get notified when that variable is proven, and we increment                   //
                // numUnmetRequirements to indicate how many notifications we need to get before we                    //
                // know all requirements are satisfied.                                                                //
                numUnmetRequirements += 1;                                                                             // 602
                variable.requirementDependents.push(tokenId);                                                          // 603
              }                                                                                                        // 604
            });                                                                                                        // 605
          })();                                                                                                        // 590
        } else if (requirement.userIsAdmin) {                                                                          // 606
          var accountId = requirement.userIsAdmin;                                                                     // 607
          var variable = _this6.getUserIsAdminVariable(accountId);                                                     // 608
          if (!variable.value) {                                                                                       // 609
            numUnmetRequirements += 1;                                                                                 // 610
            variable.requirementDependents.push(tokenId);                                                              // 611
          }                                                                                                            // 612
        } else if (requirement.tokenValid) {                                                                           // 613
          var reqTokenId = requirement.tokenValid;                                                                     // 614
          var _variable = _this6.getVariable("tokenValid", "t:" + reqTokenId, "canAccess");                            // 615
          if (!_variable.value) {                                                                                      // 616
            numUnmetRequirements += 1;                                                                                 // 617
            _variable.requirementDependents.push(tokenId);                                                             // 618
          }                                                                                                            // 619
        } else {                                                                                                       // 620
          throw new Error("unknown kind of requirement: " + JSON.stringify(requirement));                              // 621
        }                                                                                                              // 622
      });                                                                                                              // 623
    }                                                                                                                  // 624
                                                                                                                       //
    return numUnmetRequirements;                                                                                       // 626
  };                                                                                                                   // 627
                                                                                                                       //
  Context.prototype.activateToken = function activateToken(tokenId) {                                                  //
    var _this7 = this;                                                                                                 // 629
                                                                                                                       //
    // Includes a new token (which must already be in `this.tokensById`) in our computation. The                       //
    // tricky part here is dealing with our already-accumulated knowledge; we need to compute how                      //
    // many of the token's requirements are currently unmet and whether we need to push anything new                   //
    // onto `setToTrueStack`.                                                                                          //
                                                                                                                       //
    check(tokenId, String);                                                                                            // 635
    if (tokenId in this.activeTokens) {                                                                                // 636
      return false;                                                                                                    // 637
    }                                                                                                                  // 638
                                                                                                                       //
    var token = this.tokensById[tokenId];                                                                              // 640
    var grainId = token.grainId;                                                                                       // 641
    var viewInfo = this.grains[grainId].cachedViewInfo || {};                                                          // 642
    var tokenPermissions = PermissionSet.fromRoleAssignment(token.roleAssignment, viewInfo);                           // 643
                                                                                                                       //
    var sharerId = token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId;                             // 645
    var recipientId = vertexIdOfTokenOwner(token);                                                                     // 646
                                                                                                                       //
    var numUnmetRequirements = this.registerInterestInRequirements(tokenId, token.requirements);                       // 648
    var activeToken = new ActiveToken(tokenId, token.requirements, numUnmetRequirements, tokenPermissions.array, grainId, recipientId);
                                                                                                                       //
    // Add all edges represented by this token (one for each permission).                                              //
    forEachPermission(tokenPermissions.array, function (permissionId) {                                                // 653
      var recipientVariable = _this7.getVariable(grainId, recipientId, permissionId);                                  // 654
      if (!recipientVariable.value) {                                                                                  // 655
        var sharerVariable = _this7.getVariable(grainId, sharerId, permissionId);                                      // 656
        if (!sharerVariable.value) {                                                                                   // 657
          // Not proven yet that the source has this permission, so add to its direct dependents so                    //
          // that we get notified if that changes.                                                                     //
          sharerVariable.directDependents.push(tokenId);                                                               // 660
        } else {                                                                                                       // 661
          // The source has already been proven.                                                                       //
          activeToken.setReceivesPermission(permissionId, _this7);                                                     // 663
        }                                                                                                              // 664
      }                                                                                                                // 665
    });                                                                                                                // 666
                                                                                                                       //
    this.activeTokens[tokenId] = activeToken;                                                                          // 668
                                                                                                                       //
    return true;                                                                                                       // 670
  };                                                                                                                   // 671
                                                                                                                       //
  Context.prototype.activateTokenValidToken = function activateTokenValidToken(tokenId) {                              //
    // Like `activateToken()`, but for a token that appears in a `tokenValid` requirement.                             //
    // Such tokens require some special handling to fit into our computation.                                          //
                                                                                                                       //
    check(tokenId, String);                                                                                            // 677
    if (tokenId in this.activeTokens) {                                                                                // 678
      return false;                                                                                                    // 679
    }                                                                                                                  // 680
                                                                                                                       //
    var token = this.tokensById[tokenId];                                                                              // 682
    if (!token) {                                                                                                      // 683
      return false;                                                                                                    // 684
    }                                                                                                                  // 685
                                                                                                                       //
    var numUnmetRequirements = this.registerInterestInRequirements(tokenId, token.requirements);                       // 687
    var activeToken = new ActiveToken(tokenId, token.requirements, numUnmetRequirements, [], "tokenValid", "t:" + tokenId);
                                                                                                                       //
    var recipientId = "t:" + tokenId;                                                                                  // 691
    var sharerVariable = token.parentToken && this.getVariable("tokenValid", "t:" + token.parentToken, "canAccess");   // 692
                                                                                                                       //
    var recipientVariable = this.getVariable("tokenValid", recipientId, "canAccess");                                  // 695
    if (!recipientVariable.value) {                                                                                    // 696
      if (!token.parentToken || sharerVariable && sharerVariable.value) {                                              // 697
        // The source has already been proven.                                                                         //
        activeToken.setReceivesPermission("canAccess", this);                                                          // 699
      } else {                                                                                                         // 700
        // Not proven yet that the source has this permission, so add to its direct dependents so                      //
        // that we get notified if that changes.                                                                       //
        sharerVariable.directDependents.push(tokenId);                                                                 // 703
      }                                                                                                                // 704
    }                                                                                                                  // 705
                                                                                                                       //
    this.activeTokens[tokenId] = activeToken;                                                                          // 707
                                                                                                                       //
    return true;                                                                                                       // 709
  };                                                                                                                   // 710
                                                                                                                       //
  Context.prototype.getVariable = function getVariable(grainId, vertexId, permissionId) {                              //
    check(grainId, String);                                                                                            // 713
    check(vertexId, String);                                                                                           // 714
    check(permissionId, PermissionId);                                                                                 // 715
                                                                                                                       //
    if (!this.variables[grainId]) {                                                                                    // 717
      this.variables[grainId] = {};                                                                                    // 718
    }                                                                                                                  // 719
                                                                                                                       //
    if (!this.variables[grainId][vertexId]) {                                                                          // 721
      this.variables[grainId][vertexId] = new Array();                                                                 // 722
    }                                                                                                                  // 723
                                                                                                                       //
    if (!this.variables[grainId][vertexId][permissionId]) {                                                            // 725
      this.variables[grainId][vertexId][permissionId] = new Variable();                                                // 726
    }                                                                                                                  // 727
                                                                                                                       //
    return this.variables[grainId][vertexId][permissionId];                                                            // 729
  };                                                                                                                   // 730
                                                                                                                       //
  Context.prototype.getUserIsAdminVariable = function getUserIsAdminVariable(accountId) {                              //
    check(accountId, String);                                                                                          // 733
                                                                                                                       //
    if (!this.userIsAdminVariables[accountId]) {                                                                       // 735
      this.userIsAdminVariables[accountId] = new Variable();                                                           // 736
    }                                                                                                                  // 737
                                                                                                                       //
    return this.userIsAdminVariables[accountId];                                                                       // 739
  };                                                                                                                   // 740
                                                                                                                       //
  Context.prototype.getPermissions = function getPermissions(grainId, vertexId) {                                      //
    // Looks up the permissions that have already been proven for the `vertexId` on `grainId`.                         //
                                                                                                                       //
    check(grainId, String);                                                                                            // 745
    check(vertexId, String);                                                                                           // 746
                                                                                                                       //
    if (!this.getVariable(grainId, vertexId, "canAccess").value) {                                                     // 748
      return null;                                                                                                     // 749
    } else {                                                                                                           // 750
      var length = this.variables[grainId][vertexId].length;                                                           // 751
      var permissions = new Array(length);                                                                             // 752
      for (var idx = 0; idx < length; ++idx) {                                                                         // 753
        if (this.variables[grainId][vertexId][idx]) {                                                                  // 754
          permissions[idx] = !!this.variables[grainId][vertexId][idx].value;                                           // 755
        } else {                                                                                                       // 756
          permissions[idx] = false;                                                                                    // 757
        }                                                                                                              // 758
      }                                                                                                                // 759
                                                                                                                       //
      return new PermissionSet(permissions);                                                                           // 761
    }                                                                                                                  // 762
  };                                                                                                                   // 763
                                                                                                                       //
  Context.prototype.runForwardChaining = function runForwardChaining(grainId, vertexId, permissionSet) {               //
    var _this8 = this;                                                                                                 // 765
                                                                                                                       //
    // Runs forward-chaining, consuming elements from `this.setToTrueStack` and propagating                            //
    // their permissions, until we've proven that `(grainId, vertexId)` has the permissions in                         //
    // `permissionSet`, or until we've exhausted `this.setToTrueStack`.                                                //
    //                                                                                                                 //
    // TODO(perf): Exit early if we've already proven that permissionSet is fulfilled.                                 //
                                                                                                                       //
    check(grainId, String);                                                                                            // 772
    check(vertexId, String);                                                                                           // 773
    check(permissionSet, PermissionSet);                                                                               // 774
                                                                                                                       //
    if (permissionSet.array.length > 0) {                                                                              // 776
      // Make sure that the result of this call, retrieved through `this.getPermissions()`,                            //
      // will have a full array of permissions, even if they won't all be set to `true`.                               //
      this.getVariable(grainId, vertexId, permissionSet.array.length - 1);                                             // 779
    }                                                                                                                  // 780
                                                                                                                       //
    var _loop = function _loop() {                                                                                     // 765
      var current = _this8.setToTrueStack.pop();                                                                       // 783
      var variable = _this8.getVariable(current.grainId, current.vertexId, current.permissionId);                      // 784
      if (variable.value) {                                                                                            // 785
        return "continue";                                                                                             // 786
      }                                                                                                                // 787
                                                                                                                       //
      // For the first time, this vertex is now known to be satisfied.                                                 //
      variable.value = true;                                                                                           // 790
                                                                                                                       //
      // For each edge (token) whose source is this vertex, mark that the input permission is                          //
      // fulfilled.                                                                                                    //
      variable.responsibleTokenId = current.responsibleTokenId;                                                        // 794
      variable.directDependents.forEach(function (tokenId) {                                                           // 795
        // We know this permission must be met now. We also know that the permission was not met                       //
        // for this token previously becaues a token has exactly one source vertex for each                            //
        // permission, and we're processing that vertex now.                                                           //
                                                                                                                       //
        _this8.activeTokens[tokenId].setReceivesPermission(current.permissionId, _this8);                              // 800
      });                                                                                                              // 801
                                                                                                                       //
      // For each token that has a requirement on this vertex, mark that one of its requirements                       //
      // has ben fulfilled.                                                                                            //
      variable.requirementDependents.forEach(function (tokenId) {                                                      // 805
        _this8.activeTokens[tokenId].decrementRequirements(_this8);                                                    // 806
      });                                                                                                              // 807
    };                                                                                                                 // 765
                                                                                                                       //
    while (this.setToTrueStack.length > 0) {                                                                           // 782
      var _ret2 = _loop();                                                                                             // 782
                                                                                                                       //
      if (_ret2 === "continue") continue;                                                                              // 782
    }                                                                                                                  // 808
                                                                                                                       //
    return this.getPermissions(grainId, vertexId);                                                                     // 810
  };                                                                                                                   // 811
                                                                                                                       //
  Context.prototype.activateRelevantTokens = function activateRelevantTokens(grainId, vertexId) {                      //
    var _this9 = this;                                                                                                 // 813
                                                                                                                       //
    // Returns true if more computation might yield more progress.                                                     //
                                                                                                                       //
    check(grainId, String);                                                                                            // 816
    check(vertexId, String);                                                                                           // 817
                                                                                                                       //
    var result = false;                                                                                                // 819
    var relevant = computeRelevantTokens(this, grainId, vertexId);                                                     // 820
    if (this.activateOwnerEdges(grainId, relevant.ownerEdges)) {                                                       // 821
      result = true;                                                                                                   // 822
    }                                                                                                                  // 823
                                                                                                                       //
    relevant.tokenIds.forEach(function (tokenId) {                                                                     // 825
      if (_this9.activateToken(tokenId)) {                                                                             // 826
        result = true;                                                                                                 // 827
      }                                                                                                                // 828
    });                                                                                                                // 829
                                                                                                                       //
    return result;                                                                                                     // 831
  };                                                                                                                   // 832
                                                                                                                       //
  Context.prototype.processUnmetRequirements = function processUnmetRequirements(db) {                                 //
    var _this10 = this;                                                                                                // 834
                                                                                                                       //
    // Activate all tokens relevant to the requirements in `unmetRequirements`. May do a database                      //
    // query to look up new tokens.                                                                                    //
    //                                                                                                                 //
    // Returns true if more computation might yield more progress, i.e., at least one token was                        //
    // newly-activated.                                                                                                //
                                                                                                                       //
    var grainIds = this.unmetRequirements.getGrainIds().filter(function (grainId) {                                    // 841
      return !(grainId in _this10.grains);                                                                             // 842
    });                                                                                                                // 842
                                                                                                                       //
    if (db) {                                                                                                          // 844
      this.addGrains(db, grainIds);                                                                                    // 845
    }                                                                                                                  // 846
                                                                                                                       //
    var result = false;                                                                                                // 848
                                                                                                                       //
    // As we process our requirements, we might find new unmet requirments.                                            //
    // We defer processing those until the next time around.                                                           //
    var oldUnmetRequirements = this.unmetRequirements;                                                                 // 852
    this.unmetRequirements = new RequirementSet();                                                                     // 853
                                                                                                                       //
    oldUnmetRequirements.forEach(function (req) {                                                                      // 855
      if (req.permissionsHeld) {                                                                                       // 856
        var next = req.permissionsHeld;                                                                                // 857
        var nextVertexId = vertexIdOfPermissionsHeld(next);                                                            // 858
        // Activate all tokens relevant to this requirement.                                                           //
        // TODO(perf): We're actually overestimating, because we're activating tokens relevant to                      //
        //   *all* permissions rather than just the permissions specified by the requirement. E.g.                     //
        //   if the requirement is that Bob has write access, then tokens which only transmit read                     //
        //   access are not relevant, but we'll end up activating them anyway.                                         //
        if (_this10.activateRelevantTokens(next.grainId, nextVertexId)) {                                              // 864
          result = true;                                                                                               // 865
        }                                                                                                              // 866
      } else if (req.tokenValid) {                                                                                     // 867
        // Active the token and all of its transitive parents.                                                         //
        var currentTokenId = req.tokenValid;                                                                           // 869
        while (true) {                                                                                                 // 870
          var currentToken = _this10.tokensById[currentTokenId];                                                       // 871
          if (!currentToken && db) {                                                                                   // 872
            currentToken = db.collections.apiTokens.findOne({                                                          // 873
              _id: currentTokenId,                                                                                     // 874
              revoked: { $ne: true },                                                                                  // 875
              suspended: { $ne: true }                                                                                 // 876
            });                                                                                                        // 873
            _this10.tokensById[currentTokenId] = currentToken;                                                         // 878
          }                                                                                                            // 879
                                                                                                                       //
          if (!currentToken) {                                                                                         // 881
            break;                                                                                                     // 882
          }                                                                                                            // 883
                                                                                                                       //
          if (_this10.activateTokenValidToken(currentTokenId)) {                                                       // 885
            result = true;                                                                                             // 886
          }                                                                                                            // 887
                                                                                                                       //
          if (currentToken.parentToken) {                                                                              // 889
            currentTokenId = currentToken.parentToken;                                                                 // 890
          } else {                                                                                                     // 891
            break;                                                                                                     // 892
          }                                                                                                            // 893
        }                                                                                                              // 894
      } else if (req.userIsAdmin) {                                                                                    // 895
        var accountId = req.userIsAdmin;                                                                               // 896
        if (!(accountId in _this10.adminUsers) && db) {                                                                // 897
          Meteor.users.find({ isAdmin: true }).forEach(function (user) {                                               // 898
            _this10.adminUsers[user._id] = true;                                                                       // 899
          });                                                                                                          // 900
        }                                                                                                              // 901
                                                                                                                       //
        if (_this10.adminUsers[accountId]) {                                                                           // 903
          var variable = _this10.getUserIsAdminVariable(accountId);                                                    // 904
          variable.value = true;                                                                                       // 905
                                                                                                                       //
          // Might have some requirement dependents. Cannot have any direct depependents.                              //
          variable.requirementDependents.forEach(function (tokenId) {                                                  // 908
            result = true;                                                                                             // 909
            _this10.activeTokens[tokenId].decrementRequirements(_this10);                                              // 910
          });                                                                                                          // 911
        }                                                                                                              // 912
      } else {                                                                                                         // 913
        throw new Error("unknown kind of requirement: " + JSON.stringify(req));                                        // 914
      }                                                                                                                // 915
    });                                                                                                                // 916
                                                                                                                       //
    return result;                                                                                                     // 918
  };                                                                                                                   // 919
                                                                                                                       //
  Context.prototype.tryToProve = function tryToProve(grainId, vertexId, permissionSet, db) {                           //
    // Tries to prove that `vertexId` has the given permissions on the given grain. Returns a                          //
    // `PermissionSet` representing the permissions proven, or null if it has not been proved                          //
    // yet that the vertex even has access to the grain.                                                               //
                                                                                                                       //
    check(grainId, String);                                                                                            // 926
    check(vertexId, String);                                                                                           // 927
    check(permissionSet, PermissionSet);                                                                               // 928
    check(db, Match.OneOf(undefined, SandstormDb));                                                                    // 929
    // If `db` is not provided, then this function will make no database queries.                                      //
                                                                                                                       //
    if (db) {                                                                                                          // 932
      this.addGrains(db, [grainId]);                                                                                   // 933
    }                                                                                                                  // 934
                                                                                                                       //
    this.activateRelevantTokens(grainId, vertexId);                                                                    // 936
    while (true) {                                                                                                     // 937
      var result = this.runForwardChaining(grainId, vertexId, permissionSet);                                          // 938
      if (result && permissionSet.isSubsetOf(result)) {                                                                // 939
        return result;                                                                                                 // 940
      }                                                                                                                // 941
                                                                                                                       //
      if (!this.processUnmetRequirements(db)) {                                                                        // 943
        return result;                                                                                                 // 944
      }                                                                                                                // 945
    }                                                                                                                  // 946
  };                                                                                                                   // 947
                                                                                                                       //
  Context.prototype.getResponsibleTokens = function getResponsibleTokens(grainId, vertexId) {                          //
    // For the permissions that we've already proven must be held by `vertexId`, transitively finds                    //
    // the tokens that we have used in that proof, including tokens responsible for fulfilling                         //
    // membrane requirements.                                                                                          //
    //                                                                                                                 //
    // Whenever we prove a fact, we keep track of the immediately responsible token for that fact,                     //
    // This function works by walking backwards in the sharing graph, following this trail of                          //
    // "responsible tokens".                                                                                           //
    //                                                                                                                 //
    // Returns an object with two fields:                                                                              //
    //    tokenIds: list of IDs of the responsible tokens.                                                             //
    //    grainIds: list of IDs of all relevant grains.                                                                //
                                                                                                                       //
    check(grainId, String);                                                                                            // 962
    check(vertexId, String);                                                                                           // 963
                                                                                                                       //
    var stack = []; // [{ grainId: String, vertexId: String, permissionId: PermissionId }]                             // 965
    var visited = new Array(); // grainId -> vertexId -> permissionId -> bool;                                         // 966
                                                                                                                       //
    function pushVertex(grainId, vertexId, permissionId) {                                                             // 968
      if (!visited[grainId]) {                                                                                         // 969
        visited[grainId] = {};                                                                                         // 970
      }                                                                                                                // 971
                                                                                                                       //
      if (!visited[grainId][vertexId]) {                                                                               // 973
        visited[grainId][vertexId] = {};                                                                               // 974
      }                                                                                                                // 975
                                                                                                                       //
      var vertex = visited[grainId][vertexId];                                                                         // 977
      if (!vertex[permissionId]) {                                                                                     // 978
        vertex[permissionId] = true;                                                                                   // 979
        stack.push({ grainId: grainId, vertexId: vertexId, permissionId: permissionId });                              // 980
      }                                                                                                                // 981
    }                                                                                                                  // 982
                                                                                                                       //
    var neededTokens = {}; // TokenId -> bool                                                                          // 984
                                                                                                                       //
    forEachPermission(this.getPermissions(grainId, vertexId).array, function (permissionId) {                          // 986
      pushVertex(grainId, vertexId, permissionId);                                                                     // 987
    });                                                                                                                // 988
                                                                                                                       //
    while (stack.length > 0) {                                                                                         // 990
      var _current = stack.pop();                                                                                      // 991
      var variable = this.getVariable(_current.grainId, _current.vertexId, _current.permissionId);                     // 992
      var tokenId = variable.responsibleTokenId;                                                                       // 993
      if (tokenId) {                                                                                                   // 994
        var token = this.tokensById[tokenId];                                                                          // 995
                                                                                                                       //
        if (token.grainId && !token.objectId) {                                                                        // 997
          var sharerId = token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId;                       // 998
          pushVertex(token.grainId, sharerId, _current.permissionId);                                                  // 999
        } else if (token.parentToken) {                                                                                // 1000
          pushVertex("tokenValid", "t:" + token.parentToken, "canAccess");                                             // 1001
        }                                                                                                              // 1002
                                                                                                                       //
        if (!neededTokens[tokenId]) {                                                                                  // 1004
          neededTokens[tokenId] = true;                                                                                // 1005
          if (token.requirements) {                                                                                    // 1006
            token.requirements.forEach(function (requirement) {                                                        // 1007
              if (requirement.permissionsHeld) {                                                                       // 1008
                (function () {                                                                                         // 1008
                  var held = requirement.permissionsHeld;                                                              // 1009
                  var reqVertexId = held.identityId ? "i:" + held.identityId : "t:" + held.tokenId;                    // 1010
                  forEachPermission(requirement.permissionsHeld.permissions, function (permissionId) {                 // 1011
                    pushVertex(requirement.permissionsHeld.grainId, reqVertexId, permissionId);                        // 1012
                  });                                                                                                  // 1013
                })();                                                                                                  // 1008
              } else if (requirement.tokenValid) {                                                                     // 1014
                pushVertex("tokenValid", "t:" + requirement.tokenValid, "canAccess");                                  // 1015
              }                                                                                                        // 1016
            });                                                                                                        // 1017
          }                                                                                                            // 1018
        }                                                                                                              // 1019
      }                                                                                                                // 1020
    }                                                                                                                  // 1021
                                                                                                                       //
    return { tokenIds: Object.keys(neededTokens), grainIds: Object.keys(visited) };                                    // 1023
  };                                                                                                                   // 1024
                                                                                                                       //
  return Context;                                                                                                      //
}();                                                                                                                   //
                                                                                                                       //
function computeRelevantTokens(context, grainId, vertexId) {                                                           // 1027
  // Finds all tokens in `context` that could possibly carry permissions of the grain `grainId` to                     //
  // the vertex `vertexId` -- that is, all tokens that are contained in a path starting at the                         //
  // grain owner and ending at `vertexId`. Ignores any requirements that those tokens might be                         //
  // conditional upon.                                                                                                 //
  //                                                                                                                   //
  // Returns an object with two fields:                                                                                //
  //    tokenIds: list of relevant token IDs.                                                                          //
  //    ownerEdges: objects of the form { identityId: String, role: RoleAssignment }, representing                     //
  //                initial pseudo-edges in the graph. `identityId` is typically an identity of                        //
  //                the grain's owning user, but for the case of a legacy public grain it could                        //
  //                be any identity.                                                                                   //
  //                                                                                                                   //
  // Works by traversing the sharing graph twice: first backwards starting from `vertexId`, then                       //
  // forwards starting from the grain owner using only those tokens touched in the first step.                         //
  //                                                                                                                   //
  // `context` contains all the information from the database which is available for now. This call                    //
  // will not make any new database lookups; edges not listed in `context` will not be considered                      //
  // (as if they'd been revoked).                                                                                      //
                                                                                                                       //
  check(context, Context);                                                                                             // 1047
  check(grainId, String);                                                                                              // 1048
  check(vertexId, String);                                                                                             // 1049
                                                                                                                       //
  var grain = context.grains[grainId];                                                                                 // 1051
  if (!grain) return { tokenIds: [], ownerEdges: [] };                                                                 // 1052
  var viewInfo = grain.cachedViewInfo || {};                                                                           // 1053
  var ownerIdentityIds = context.userIdentityIds[grain.userId];                                                        // 1054
                                                                                                                       //
  var vertexStack = []; // Vertex IDs that we need to explore.                                                         // 1056
  var visitedVertexIds = {}; // Set of vertex IDs that we have already enqueued to get explored.                       // 1057
                                                                                                                       //
  visitedVertexIds[vertexId] = true;                                                                                   // 1059
  vertexStack.push(vertexId);                                                                                          // 1060
                                                                                                                       //
  var visitedTokensBySharerId = {};                                                                                    // 1062
  var ownerEdges = [];                                                                                                 // 1063
                                                                                                                       //
  // Repeatedly pop a vertex from the stack, find all its incoming edges (i.e. all other vertexes                      //
  // that share permissions to this vertex), and push those vertexes onto the stack.                                   //
                                                                                                                       //
  var _loop2 = function _loop2() {                                                                                     // 1027
    var vertexId = vertexStack.pop();                                                                                  // 1068
                                                                                                                       //
    var incomingEdges = [];                                                                                            // 1070
    // List of edges in the sharing graph ending at this vertex. Each is an object with the fields:                    //
    //     sharerId: The vertex ID of the edge's source.                                                               //
    //     token: the token object backing this edge, if there is one.                                                 //
                                                                                                                       //
    function tokenToEdge(token) {                                                                                      // 1075
      // Convert an ApiToken into an edge.                                                                             //
      return {                                                                                                         // 1077
        token: token,                                                                                                  // 1078
        sharerId: token.parentToken ? "t:" + token.parentToken : "i:" + token.identityId                               // 1079
      };                                                                                                               // 1077
    }                                                                                                                  // 1081
                                                                                                                       //
    if (vertexId.slice(0, 2) === "o:") {                                                                               // 1083
      // Owner. We don't need to do anything.                                                                          //
      incomingEdges = [];                                                                                              // 1085
    } else if (vertexId.slice(0, 2) === "t:") {                                                                        // 1086
      // A webkey token. Extract it from the context (or ignore if it isn't present).                                  //
      var _token = context.tokensById[vertexId.slice(2)];                                                              // 1088
      if (_token) {                                                                                                    // 1089
        incomingEdges = [tokenToEdge(_token)];                                                                         // 1090
      }                                                                                                                // 1091
    } else if (vertexId.slice(0, 2) === "i:") {                                                                        // 1092
      // An identity.                                                                                                  //
      var identityId = vertexId.slice(2);                                                                              // 1094
      if (ownerIdentityIds.indexOf(identityId) >= 0) {                                                                 // 1095
        // This is one of the owner's identities.                                                                      //
        incomingEdges = [{ sharerId: "o:Owner" }];                                                                     // 1097
        ownerEdges.push({ identityId: identityId, role: { allAccess: null } });                                        // 1098
      } else if (!grain["private"]) {                                                                                  // 1099
        // This is a legacy "public" grain, meaning that any user who knows the grain ID receives                      //
        // the grain's default role. If the user doesn't know the grain ID then they are unable                        //
        // to express a request to open the grain in the first place and we'll never get to the                        //
        // point of this permissions computation, so for this purpose we can assume all users                          //
        // have the default role. (Similarly, a user who doesn't know the grain ID couldn't                            //
        // possibly be the subject of any MembraneRequirements against the grain because they                          //
        // have never interacted with the grain and so couldn't have caused such                                       //
        // MembraneRequiments to come about. Note that this is kind of shaky non-local reasoning,                      //
        // but literally no such legacy grain has been created since early 2015 and none will ever                     //
        // be created again, so it's not a huge deal.)                                                                 //
        incomingEdges = [{ sharerId: "o:Owner" }];                                                                     // 1110
        ownerEdges.push({ identityId: identityId, role: { none: null } });                                             // 1111
      } else {                                                                                                         // 1112
        // Not a special case. Gather all tokens where this user is the recipient.                                     //
        incomingEdges = ((context.tokensByRecipient[grainId] || {})[vertexId.slice(2)] || []).map(tokenToEdge);        // 1114
      }                                                                                                                // 1116
    } else {                                                                                                           // 1117
      throw new Meteor.Error(500, "Unrecognized vertex ID: " + vertexId);                                              // 1118
    }                                                                                                                  // 1119
                                                                                                                       //
    // For each edge incoming to this vertex, backpropagate this vertex's PermissionFlow to the                        //
    // source vertex, joining it with the edge's constraints.                                                          //
    incomingEdges.forEach(function (edge) {                                                                            // 1123
      var sharerId = edge.sharerId;                                                                                    // 1124
      if (edge.token) {                                                                                                // 1125
        if (!visitedTokensBySharerId[sharerId]) {                                                                      // 1126
          visitedTokensBySharerId[sharerId] = {};                                                                      // 1127
        }                                                                                                              // 1128
                                                                                                                       //
        visitedTokensBySharerId[sharerId][edge.token._id] = edge.token;                                                // 1130
      }                                                                                                                // 1131
                                                                                                                       //
      if (!visitedVertexIds[sharerId]) {                                                                               // 1133
        // Never saw this vertex before.                                                                               //
        visitedVertexIds[sharerId] = true;                                                                             // 1135
        vertexStack.push(sharerId);                                                                                    // 1136
      }                                                                                                                // 1137
    });                                                                                                                // 1139
  };                                                                                                                   // 1027
                                                                                                                       //
  while (vertexStack.length > 0) {                                                                                     // 1067
    _loop2();                                                                                                          // 1067
  }                                                                                                                    // 1140
                                                                                                                       //
  // Now walk forward from the owner.                                                                                  //
  var relevantTokens = {};                                                                                             // 1143
  var visitedSharers = {};                                                                                             // 1144
                                                                                                                       //
  var sharerStack = [];                                                                                                // 1146
  ownerIdentityIds.forEach(function (identityId) {                                                                     // 1147
    sharerStack.push("i:" + identityId);                                                                               // 1147
  });                                                                                                                  // 1147
  while (sharerStack.length > 0) {                                                                                     // 1148
    var sharerId = sharerStack.pop();                                                                                  // 1149
    for (var tokenId in visitedTokensBySharerId[sharerId]) {                                                           // 1150
      relevantTokens[tokenId] = true;                                                                                  // 1151
      var token = visitedTokensBySharerId[sharerId][tokenId];                                                          // 1152
      var recipientId = vertexIdOfTokenOwner(token);                                                                   // 1153
                                                                                                                       //
      if (!visitedSharers[recipientId]) {                                                                              // 1155
        visitedSharers[recipientId] = true;                                                                            // 1156
        sharerStack.push(recipientId);                                                                                 // 1157
      }                                                                                                                // 1158
    }                                                                                                                  // 1159
  }                                                                                                                    // 1160
                                                                                                                       //
  return {                                                                                                             // 1162
    tokenIds: Object.keys(relevantTokens),                                                                             // 1163
    ownerEdges: ownerEdges                                                                                             // 1164
  };                                                                                                                   // 1162
}                                                                                                                      // 1166
                                                                                                                       //
var vertexPattern = Match.OneOf({ token: Match.ObjectIncluding({ _id: String, grainId: String }) }, {                  // 1168
  grain: Match.ObjectIncluding({                                                                                       // 1171
    _id: String,                                                                                                       // 1172
    identityId: Match.OneOf(String, null, undefined)                                                                   // 1173
  })                                                                                                                   // 1171
});                                                                                                                    // 1170
// A vertex in the sharing graph is a principal, e.g. a user (identity) or a token. Complicating                       //
// matters, we may have to traverse sharing graphs for multiple grains in the same computation. A                      //
// token is specific to one grain, but a user of course can have access to multiple grains, so in                      //
// the case of a user we represent the vertex as a (user, grain) pair.                                                 //
//                                                                                                                     //
// TODO(cleanup): Perhaps `grain` should be renamed to `user` or `identity`? In the common case                        //
//   where only a single grain's shares need to be considered, it feels weird to think of the                          //
//   grain ID as being the primary distinguishing feature of the vertex.                                               //
                                                                                                                       //
SandstormPermissions.mayOpenGrain = function (db, vertex) {                                                            // 1186
  // Determines whether the vertex is allowed to open the grain. May make multiple database                            //
  // queries.                                                                                                          //
                                                                                                                       //
  check(vertex, vertexPattern);                                                                                        // 1190
  var grainId = vertex.token ? vertex.token.grainId : vertex.grain._id;                                                // 1191
  var vertexId = vertex.token ? "t:" + vertex.token._id : "i:" + vertex.grain.identityId;                              // 1192
  var context = new Context();                                                                                         // 1193
  var emptyPermissions = new PermissionSet([]);                                                                        // 1194
  return !!context.tryToProve(grainId, vertexId, emptyPermissions, db);                                                // 1195
};                                                                                                                     // 1196
                                                                                                                       //
var CompoundObserveHandle = function () {                                                                              //
  function CompoundObserveHandle() {                                                                                   // 1199
    _classCallCheck(this, CompoundObserveHandle);                                                                      // 1199
                                                                                                                       //
    this._handles = [];                                                                                                // 1200
  }                                                                                                                    // 1201
                                                                                                                       //
  CompoundObserveHandle.prototype.push = function push(handle) {                                                       //
    this._handles.push(handle);                                                                                        // 1204
  };                                                                                                                   // 1205
                                                                                                                       //
  CompoundObserveHandle.prototype.stop = function stop() {                                                             //
    this._handles.forEach(function (handle) {                                                                          // 1208
      return handle.stop();                                                                                            // 1208
    });                                                                                                                // 1208
  };                                                                                                                   // 1209
                                                                                                                       //
  return CompoundObserveHandle;                                                                                        //
}();                                                                                                                   //
                                                                                                                       //
SandstormPermissions.grainPermissions = function (db, vertex, viewInfo, onInvalidated) {                               // 1212
  // Computes the set of permissions received by `vertex`. Returns an object with a                                    //
  // `permissions` field containing the computed permissions. If the field is null then                                //
  // the `vertex` does not even have the base "allowed to access at all" permission.                                   //
  //                                                                                                                   //
  // `onInvalidated` is an optional callback. If provided, it will be called when the result                           //
  // has been invalidated. If `onValidated` is provided, the result of `grainPermissions` will                         //
  // have a `observeHandle` field, containing an object with a `stop()` method that must be                            //
  // called once the computation becomes so longer relevant.                                                           //
                                                                                                                       //
  check(db, SandstormDb);                                                                                              // 1222
  check(vertex, vertexPattern);                                                                                        // 1223
  var grainId = vertex.token ? vertex.token.grainId : vertex.grain._id;                                                // 1224
  var vertexId = vertex.token ? "t:" + vertex.token._id : "i:" + vertex.grain.identityId;                              // 1225
                                                                                                                       //
  var resultPermissions = void 0;                                                                                      // 1227
  var observeHandle = void 0;                                                                                          // 1228
  var onInvalidatedActive = false;                                                                                     // 1229
                                                                                                                       //
  var startTime = new Date();                                                                                          // 1231
  function measureElapsedTime(result) {                                                                                // 1232
    var elapsedMilliseconds = new Date() - startTime;                                                                  // 1233
    if (elapsedMilliseconds > 200) {                                                                                   // 1234
      console.log("Warning: SandstormPermissions.grainPermissions() took " + elapsedMilliseconds + " milliseconds to complete for the vertex " + JSON.stringify(vertex));
    }                                                                                                                  // 1237
  }                                                                                                                    // 1238
                                                                                                                       //
  // Our computation proceeds in two phases. In the first, we determine which permissions the vertex                   //
  // appears to have and we compute set of tokens which appears to be sufficent to prove those                         //
  // permissions. However, concurrent database modifications may render the computation invalid, so                    //
  // in the second phases we verify that our proof is still valid and arrange for onInvalidated                        //
  // to be called when necessary. This is an optimisistic approach to concurrency. If the                              //
  // verification phase fails, we try again before giving up entirely.                                                 //
                                                                                                                       //
  var _loop3 = function _loop3(attemptCount) {                                                                         // 1212
    if (observeHandle) {                                                                                               // 1247
      observeHandle.stop();                                                                                            // 1248
      observeHandle = null;                                                                                            // 1249
    }                                                                                                                  // 1250
                                                                                                                       //
    var context = new Context();                                                                                       // 1252
    var allPermissions = PermissionSet.fromRoleAssignment({ allAccess: null }, viewInfo);                              // 1253
    var firstPhasePermissions = context.tryToProve(grainId, vertexId, allPermissions, db);                             // 1254
                                                                                                                       //
    if (!firstPhasePermissions) return "break"; // No permissions; give up now.                                        // 1256
                                                                                                                       //
    var needed = context.getResponsibleTokens(grainId, vertexId);                                                      // 1258
    var neededTokens = needed.tokenIds;                                                                                // 1259
    var neededGrains = needed.grainIds;                                                                                // 1260
                                                                                                                       //
    // Phase 2: Now let's verify those permissions.                                                                    //
                                                                                                                       //
    context.reset();                                                                                                   // 1264
                                                                                                                       //
    var invalidated = false;                                                                                           // 1266
    function guardedOnInvalidated() {                                                                                  // 1267
      var shouldCall = onInvalidatedActive && !invalidated;                                                            // 1268
      invalidated = true;                                                                                              // 1269
      if (shouldCall) {                                                                                                // 1270
        onInvalidated();                                                                                               // 1271
      }                                                                                                                // 1272
    }                                                                                                                  // 1273
                                                                                                                       //
    var tokenCursor = db.collections.apiTokens.find({                                                                  // 1275
      _id: { $in: neededTokens },                                                                                      // 1276
      revoked: { $ne: true },                                                                                          // 1277
      suspended: { $ne: true },                                                                                        // 1278
      objectId: { $exists: false }                                                                                     // 1279
    });                                                                                                                // 1275
                                                                                                                       //
    if (onInvalidated) {                                                                                               // 1282
      observeHandle = new CompoundObserveHandle();                                                                     // 1283
      observeHandle.push(tokenCursor.observe({                                                                         // 1284
        changed: function changed(newApiToken, oldApiToken) {                                                          // 1285
          if (newApiToken.trashed || !_.isEqual(newApiToken.roleAssignment, oldApiToken.roleAssignment) || !_.isEqual(newApiToken.suspended, oldApiToken.suspended) || !_.isEqual(newApiToken.revoked, oldApiToken.revoked)) {
            observeHandle.stop();                                                                                      // 1290
            guardedOnInvalidated();                                                                                    // 1291
          }                                                                                                            // 1292
        },                                                                                                             // 1293
        removed: function removed(oldApiToken) {                                                                       // 1295
          observeHandle.stop();                                                                                        // 1296
          guardedOnInvalidated();                                                                                      // 1297
        }                                                                                                              // 1298
      }));                                                                                                             // 1284
                                                                                                                       //
      var grainCursor = db.collections.grains.find({ _id: { $in: neededGrains } });                                    // 1301
      observeHandle.push(grainCursor.observe({                                                                         // 1302
        changed: function changed(newGrain, oldGrain) {                                                                // 1303
          if (newGrain.trashed || newGrain.suspended || !oldGrain["private"] && newGrain["private"]) {                 // 1304
            observeHandle.stop();                                                                                      // 1307
            guardedOnInvalidated();                                                                                    // 1308
          }                                                                                                            // 1309
        },                                                                                                             // 1310
        removed: function removed(oldGrain) {                                                                          // 1312
          observeHandle.stop();                                                                                        // 1313
          guardedOnInvalidated();                                                                                      // 1314
        }                                                                                                              // 1315
      }));                                                                                                             // 1302
    }                                                                                                                  // 1317
                                                                                                                       //
    context.addTokensFromCursor(tokenCursor);                                                                          // 1319
                                                                                                                       //
    // TODO(someday): Also account for linking/unlinking of identities and accounts losing admin                       //
    //   privileges. Currently we do not call `onInvalided()` on such events. We would need to set                     //
    //   up more cursor observers.                                                                                     //
                                                                                                                       //
    resultPermissions = context.tryToProve(grainId, vertexId, firstPhasePermissions);                                  // 1325
                                                                                                                       //
    if (resultPermissions && firstPhasePermissions.isSubsetOf(resultPermissions)) {                                    // 1327
      // We've confirmed the permissions that we found the in the first phase. Done!                                   //
      return "break";                                                                                                  // 1329
    }                                                                                                                  // 1330
  };                                                                                                                   // 1212
                                                                                                                       //
  for (var attemptCount = 0; attemptCount < 3; ++attemptCount) {                                                       // 1246
    var _ret5 = _loop3(attemptCount);                                                                                  // 1246
                                                                                                                       //
    if (_ret5 === "break") break;                                                                                      // 1246
  } // for (let attemptCount ...) {                                                                                    // 1331
                                                                                                                       //
  onInvalidatedActive = true;                                                                                          // 1333
  var result = {};                                                                                                     // 1334
  result.permissions = resultPermissions && resultPermissions.array || null;                                           // 1335
  result.observeHandle = observeHandle || new CompoundObserveHandle();                                                 // 1336
  measureElapsedTime();                                                                                                // 1337
  return result;                                                                                                       // 1338
};                                                                                                                     // 1339
                                                                                                                       //
SandstormPermissions.downstreamTokens = function (db, root) {                                                          // 1341
  // Computes a list of the UiView tokens that are downstream in the sharing graph from a given                        //
  // source. The source, `root`, can either be a token or a (grain, user) pair. The exact format                       //
  // of `root` is specified in the `check()` invocation below.                                                         //
  //                                                                                                                   //
  // TODO(someday): Account for membrane requirements in this computation.                                             //
                                                                                                                       //
  check(root, Match.OneOf({ token: Match.ObjectIncluding({ _id: String, grainId: String }) }, { grain: Match.ObjectIncluding({ _id: String, identityId: String }) }));
                                                                                                                       //
  var result = [];                                                                                                     // 1351
  var tokenStack = [];                                                                                                 // 1352
  var stackedTokens = {};                                                                                              // 1353
  var tokensBySharer = {};                                                                                             // 1354
  var tokensByParent = {};                                                                                             // 1355
  var tokensById = {};                                                                                                 // 1356
                                                                                                                       //
  function addChildren(tokenId) {                                                                                      // 1358
    var children = tokensByParent[tokenId];                                                                            // 1359
    if (children) {                                                                                                    // 1360
      children.forEach(function (child) {                                                                              // 1361
        if (!stackedTokens[child._id]) {                                                                               // 1362
          tokenStack.push(child);                                                                                      // 1363
          stackedTokens[child._id] = true;                                                                             // 1364
        }                                                                                                              // 1365
      });                                                                                                              // 1366
    }                                                                                                                  // 1367
  }                                                                                                                    // 1368
                                                                                                                       //
  function addSharedTokens(sharer) {                                                                                   // 1370
    var sharedTokens = tokensBySharer[sharer];                                                                         // 1371
    if (sharedTokens) {                                                                                                // 1372
      sharedTokens.forEach(function (sharedToken) {                                                                    // 1373
        if (!stackedTokens[sharedToken._id]) {                                                                         // 1374
          tokenStack.push(sharedToken);                                                                                // 1375
          stackedTokens[sharedToken._id] = true;                                                                       // 1376
        }                                                                                                              // 1377
      });                                                                                                              // 1378
    }                                                                                                                  // 1379
  }                                                                                                                    // 1380
                                                                                                                       //
  var grainId = root.token ? root.token.grainId : root.grain._id;                                                      // 1382
  var grain = db.getGrain(grainId);                                                                                    // 1383
  if (!grain || !grain["private"]) {                                                                                   // 1384
    return result;                                                                                                     // 1384
  }                                                                                                                    // 1384
                                                                                                                       //
  db.collections.apiTokens.find({ grainId: grainId,                                                                    // 1386
    revoked: { $ne: true },                                                                                            // 1387
    suspended: { $ne: true }                                                                                           // 1388
  }).forEach(function (token) {                                                                                        // 1386
    tokensById[token._id] = token;                                                                                     // 1390
    if (token.parentToken) {                                                                                           // 1391
      if (!tokensByParent[token.parentToken]) {                                                                        // 1392
        tokensByParent[token.parentToken] = [];                                                                        // 1393
      }                                                                                                                // 1394
                                                                                                                       //
      tokensByParent[token.parentToken].push(token);                                                                   // 1396
    } else if (token.identityId) {                                                                                     // 1397
      if (!tokensBySharer[token.identityId]) {                                                                         // 1398
        tokensBySharer[token.identityId] = [];                                                                         // 1399
      }                                                                                                                // 1400
                                                                                                                       //
      tokensBySharer[token.identityId].push(token);                                                                    // 1402
    }                                                                                                                  // 1403
  });                                                                                                                  // 1404
                                                                                                                       //
  if (root.token) {                                                                                                    // 1406
    addChildren(root.token._id);                                                                                       // 1407
  } else if (root.grain) {                                                                                             // 1408
    addSharedTokens(root.grain.identityId);                                                                            // 1409
  }                                                                                                                    // 1410
                                                                                                                       //
  while (tokenStack.length > 0) {                                                                                      // 1412
    var token = tokenStack.pop();                                                                                      // 1413
    result.push(token);                                                                                                // 1414
    addChildren(token._id);                                                                                            // 1415
    if (token.owner && token.owner.user) {                                                                             // 1416
      addSharedTokens(token.owner.user.identityId);                                                                    // 1417
    }                                                                                                                  // 1418
  }                                                                                                                    // 1419
                                                                                                                       //
  return result;                                                                                                       // 1421
};                                                                                                                     // 1422
                                                                                                                       //
var HeaderSafeString = Match.Where(function (str) {                                                                    // 1424
  check(str, String);                                                                                                  // 1425
  return str.match(/^[\x20-\x7E]*$/);                                                                                  // 1426
});                                                                                                                    // 1427
                                                                                                                       //
var DavClass = Match.Where(function (str) {                                                                            // 1429
  check(str, String);                                                                                                  // 1430
  return str.match(/^[a-zA-Z0-9!#$%&'*+.^_`|~-]+$/) || str.match(/^<[\x21-\x7E]*>$/); // supposed to be a URL          // 1431
});                                                                                                                    // 1433
                                                                                                                       //
var ResourceMap = Match.Where(function (map) {                                                                         // 1435
  for (path in map) {                                                                                                  // 1436
    if (!path.match(/^\/[\x21-\x7E]*$/)) {                                                                             // 1437
      return false;                                                                                                    // 1438
    }                                                                                                                  // 1439
                                                                                                                       //
    check(map[path], {                                                                                                 // 1441
      type: HeaderSafeString,                                                                                          // 1442
      language: Match.Optional(HeaderSafeString),                                                                      // 1443
      encoding: Match.Optional(HeaderSafeString),                                                                      // 1444
      body: String                                                                                                     // 1445
    });                                                                                                                // 1441
  }                                                                                                                    // 1447
                                                                                                                       //
  return true;                                                                                                         // 1449
});                                                                                                                    // 1450
                                                                                                                       //
var LocalizedString = {                                                                                                // 1452
  defaultText: String,                                                                                                 // 1453
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 1454
};                                                                                                                     // 1452
                                                                                                                       //
SandstormPermissions.createNewApiToken = function (db, provider, grainId, petname, roleAssignment, owner, unauthenticated) {
  // Creates a new UiView API token. If `rawParentToken` is set, creates a child token.                                //
  check(grainId, String);                                                                                              // 1462
  check(petname, String);                                                                                              // 1463
  check(roleAssignment, db.roleAssignmentPattern);                                                                     // 1464
  // Meteor bug #3877: we get null here instead of undefined when we                                                   //
  // explicitly pass in undefined.                                                                                     //
  check(provider, Match.OneOf({ identityId: String, accountId: String }, { rawParentToken: Match.OneOf(String, Buffer) }));
  check(owner, Match.OneOf({                                                                                           // 1469
    webkey: Match.OneOf(null, {                                                                                        // 1470
      forSharing: Boolean,                                                                                             // 1471
      expiresIfUnusedDuration: Match.Optional(Number)                                                                  // 1472
    })                                                                                                                 // 1470
  }, {                                                                                                                 // 1469
    user: {                                                                                                            // 1475
      identityId: String,                                                                                              // 1476
      title: String,                                                                                                   // 1477
      renamed: Match.Optional(Boolean),                                                                                // 1478
      upstreamTitle: Match.Optional(String),                                                                           // 1479
      seenAllActivity: Match.Optional(Boolean)                                                                         // 1480
    }                                                                                                                  // 1475
  }, {                                                                                                                 // 1474
    grain: {                                                                                                           // 1483
      grainId: String,                                                                                                 // 1484
      saveLabel: LocalizedString,                                                                                      // 1485
      introducerIdentity: String                                                                                       // 1486
    }                                                                                                                  // 1483
  }, {                                                                                                                 // 1482
    clientPowerboxRequest: {                                                                                           // 1489
      grainId: String,                                                                                                 // 1490
      sessionId: String,                                                                                               // 1491
      introducerIdentity: Match.Optional(String) }                                                                     // 1492
  }, // obsolete                                                                                                       // 1488
  {                                                                                                                    // 1494
    frontend: null                                                                                                     // 1495
  }));                                                                                                                 // 1494
                                                                                                                       //
  check(unauthenticated, Match.OneOf(undefined, null, {                                                                // 1498
    options: Match.Optional({ dav: [Match.Optional(DavClass)] }),                                                      // 1499
    resources: Match.Optional(ResourceMap)                                                                             // 1500
  }));                                                                                                                 // 1498
                                                                                                                       //
  if (unauthenticated && JSON.stringify(unauthenticated).length > 4096) {                                              // 1503
    throw new Meteor.Error(400, "Unauthenticated params too large; limit 4kb.");                                       // 1504
  }                                                                                                                    // 1505
                                                                                                                       //
  var grain = db.getGrain(grainId);                                                                                    // 1507
  if (!grain) {                                                                                                        // 1508
    throw new Meteor.Error(403, "Unauthorized", "No grain found.");                                                    // 1509
  }                                                                                                                    // 1510
                                                                                                                       //
  var token = Random.secret();                                                                                         // 1512
  if (encodeURIComponent(token) !== token) {                                                                           // 1513
    // Sandstorm guarantees that tokens with a `clientPowerboxRequest` owner are URL-safe.                             //
    // `Random.secret()` only uses base64url characters, so we should never get here.                                  //
    throw new Meteor.Error(500, "Random.secret() returned a non-URL safe token: " + token);                            // 1516
  }                                                                                                                    // 1517
                                                                                                                       //
  var apiToken = {                                                                                                     // 1519
    _id: Crypto.createHash("sha256").update(token).digest("base64"),                                                   // 1520
    grainId: grainId,                                                                                                  // 1521
    roleAssignment: roleAssignment,                                                                                    // 1522
    petname: petname,                                                                                                  // 1523
    created: new Date(),                                                                                               // 1524
    expires: null                                                                                                      // 1525
  };                                                                                                                   // 1519
                                                                                                                       //
  var result = {};                                                                                                     // 1528
  var parentForSharing = false;                                                                                        // 1529
  if (provider.rawParentToken) {                                                                                       // 1530
    var parentToken = Crypto.createHash("sha256").update(provider.rawParentToken).digest("base64");                    // 1531
    var parentApiToken = db.collections.apiTokens.findOne({ _id: parentToken, grainId: grainId, objectId: { $exists: false } });
    if (!parentApiToken) {                                                                                             // 1534
      throw new Meteor.Error(403, "No such parent token found.");                                                      // 1535
    }                                                                                                                  // 1536
                                                                                                                       //
    if (parentApiToken.forSharing) {                                                                                   // 1538
      parentForSharing = true;                                                                                         // 1539
    }                                                                                                                  // 1540
                                                                                                                       //
    apiToken.identityId = parentApiToken.identityId;                                                                   // 1542
    apiToken.accountId = parentApiToken.accountId;                                                                     // 1543
                                                                                                                       //
    apiToken.parentToken = parentToken;                                                                                // 1545
    result.parentApiToken = parentApiToken;                                                                            // 1546
  } else if (provider.identityId) {                                                                                    // 1547
    apiToken.identityId = provider.identityId;                                                                         // 1548
    apiToken.accountId = provider.accountId;                                                                           // 1549
  }                                                                                                                    // 1550
                                                                                                                       //
  if (owner.webkey) {                                                                                                  // 1552
    // Non-null webkey is a special case not covered in ApiTokenOwner.                                                 //
    // TODO(cleanup): Maybe ApiTokenOwner.webkey should be extended with these fields?                                 //
    apiToken.owner = { webkey: null };                                                                                 // 1555
    apiToken.forSharing = parentForSharing || owner.webkey.forSharing;                                                 // 1556
    if (owner.webkey.expiresIfUnusedDuration) {                                                                        // 1557
      apiToken.expiresIfUnused = new Date(Date.now() + owner.webkey.expiresIfUnusedDuration);                          // 1558
    }                                                                                                                  // 1559
  } else if (owner.user) {                                                                                             // 1560
    var grainInfo = db.getDenormalizedGrainInfo(grainId);                                                              // 1561
    apiToken.owner = {                                                                                                 // 1562
      user: {                                                                                                          // 1563
        identityId: owner.user.identityId,                                                                             // 1564
        title: owner.user.title,                                                                                       // 1565
        denormalizedGrainMetadata: grainInfo                                                                           // 1566
      }                                                                                                                // 1563
    };                                                                                                                 // 1562
                                                                                                                       //
    if (grain.title !== owner.user.title) {                                                                            // 1570
      apiToken.owner.user.upstreamTitle = grain.title;                                                                 // 1571
    }                                                                                                                  // 1572
  } else {                                                                                                             // 1573
    // Note: Also covers the case of `webkey: null`.                                                                   //
    apiToken.owner = owner;                                                                                            // 1575
  }                                                                                                                    // 1576
                                                                                                                       //
  if (unauthenticated) {                                                                                               // 1578
    var apiHost = {                                                                                                    // 1579
      _id: db.apiHostIdHashForToken(token),                                                                            // 1580
      hash2: Crypto.createHash("sha256").update(apiToken._id).digest("base64")                                         // 1581
    };                                                                                                                 // 1579
    if (unauthenticated.options) {                                                                                     // 1583
      apiHost.options = unauthenticated.options;                                                                       // 1584
    }                                                                                                                  // 1585
                                                                                                                       //
    if (unauthenticated.resources) {                                                                                   // 1587
      // Mongo requires keys in objects to be escaped. Ugh.                                                            //
      apiHost.resources = {};                                                                                          // 1589
      for (var key in unauthenticated.resources) {                                                                     // 1590
        apiHost.resources[SandstormDb.escapeMongoKey(key)] = unauthenticated.resources[key];                           // 1591
      }                                                                                                                // 1592
    }                                                                                                                  // 1593
                                                                                                                       //
    db.collections.apiHosts.insert(apiHost);                                                                           // 1595
    apiToken.hasApiHost = true;                                                                                        // 1596
  }                                                                                                                    // 1597
                                                                                                                       //
  db.collections.apiTokens.insert(apiToken);                                                                           // 1599
                                                                                                                       //
  result.id = apiToken._id;                                                                                            // 1601
  result.token = token;                                                                                                // 1602
  return result;                                                                                                       // 1603
};                                                                                                                     // 1604
                                                                                                                       //
// Make self-destructing tokens actually self-destruct, so they don't                                                  //
// clutter the token list view.                                                                                        //
SandstormPermissions.cleanupSelfDestructing = function (db) {                                                          // 1608
  return function () {                                                                                                 // 1609
    var now = new Date();                                                                                              // 1610
    db.removeApiTokens({ expiresIfUnused: { $lt: now } });                                                             // 1611
  };                                                                                                                   // 1612
};                                                                                                                     // 1613
                                                                                                                       //
SandstormPermissions.cleanupClientPowerboxTokens = function (db) {                                                     // 1615
  return function () {                                                                                                 // 1616
    var tenMinutesAgo = new Date(Date.now() - 1000 * 60 * 10);                                                         // 1617
    db.removeApiTokens({                                                                                               // 1618
      $or: [{ "owner.clientPowerboxRequest": { $exists: true } }, { "owner.clientPowerboxOffer": { $exists: true } }],
      created: { $lt: tenMinutesAgo }                                                                                  // 1623
    });                                                                                                                // 1618
  };                                                                                                                   // 1625
};                                                                                                                     // 1626
                                                                                                                       //
Meteor.methods({                                                                                                       // 1628
  transitiveShares: function transitiveShares(identityId, grainId) {                                                   // 1629
    check(identityId, String);                                                                                         // 1630
    check(grainId, String);                                                                                            // 1631
    if (this.userId) {                                                                                                 // 1632
      var db = this.connection.sandstormDb;                                                                            // 1633
      return SandstormPermissions.downstreamTokens(db, { grain: { _id: grainId, identityId: identityId } });           // 1634
    }                                                                                                                  // 1636
  },                                                                                                                   // 1637
                                                                                                                       //
  newApiToken: function newApiToken(provider, grainId, petname, roleAssignment, owner, unauthenticated) {              // 1639
    check(provider, Match.OneOf({ identityId: String }, { rawParentToken: String }));                                  // 1640
    if (!owner.user && !owner.webkey) {                                                                                // 1641
      throw new Meteor.Error(403, "'webkey' and 'user' are the only allowed owners in newApiToken()");                 // 1642
    }                                                                                                                  // 1644
                                                                                                                       //
    // other check()s happen in SandstormPermissions.createNewApiToken().                                              //
    var db = this.connection.sandstormDb;                                                                              // 1647
    if (provider.identityId) {                                                                                         // 1648
      if (!this.userId || !db.userHasIdentity(this.userId, provider.identityId)) {                                     // 1649
        throw new Meteor.Error(403, "Not an identity of the current user: " + provider.identityId);                    // 1650
      }                                                                                                                // 1651
    }                                                                                                                  // 1652
                                                                                                                       //
    if (provider.identityId) {                                                                                         // 1654
      provider.accountId = this.userId;                                                                                // 1655
    }                                                                                                                  // 1656
                                                                                                                       //
    return SandstormPermissions.createNewApiToken(this.connection.sandstormDb, provider, grainId, petname, roleAssignment, owner, unauthenticated);
  },                                                                                                                   // 1661
                                                                                                                       //
  updateApiToken: function updateApiToken(token, newFields) {                                                          // 1663
    var db = this.connection.sandstormDb;                                                                              // 1664
                                                                                                                       //
    check(token, String);                                                                                              // 1666
    check(newFields, { petname: Match.Optional(String),                                                                // 1667
      roleAssignment: Match.Optional(db.roleAssignmentPattern),                                                        // 1668
      revoked: Match.Optional(Boolean),                                                                                // 1669
      suspended: Match.Optional(Boolean) });                                                                           // 1670
                                                                                                                       //
    if (!this.userId) {                                                                                                // 1672
      throw new Meteor.Error(403, "Must be logged in to modify a token");                                              // 1673
    }                                                                                                                  // 1674
                                                                                                                       //
    var apiToken = db.collections.apiTokens.findOne(token);                                                            // 1676
    if (!apiToken) {                                                                                                   // 1677
      throw new Meteor.Error(404, "No such token found.");                                                             // 1678
    }                                                                                                                  // 1679
                                                                                                                       //
    if (db.userHasIdentity(this.userId, apiToken.identityId)) {                                                        // 1681
      var modifier = { $set: newFields };                                                                              // 1682
      db.collections.apiTokens.update(token, modifier);                                                                // 1683
    } else {                                                                                                           // 1684
      throw new Meteor.Error(403, "User not authorized to modify this token.");                                        // 1685
    }                                                                                                                  // 1686
  }                                                                                                                    // 1687
});                                                                                                                    // 1628
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-permissions/permissions.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-permissions'] = {}, {
  SandstormPermissions: SandstormPermissions
});

})();

//# sourceMappingURL=sandstorm-permissions.js.map
